> For the complete documentation index, see [llms.txt](https://docs.postgresql.tw/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.postgresql.tw/15/server-programming/server-programming-interface/spi-interface/spi-spi-prepare-extended.md).

# SPI\_prepare\_extended

## SPI\_prepare\_extended

SPI\_prepare\_extended — prepare a statement, without executing it yet

### Synopsis

```

SPIPlanPtr SPI_prepare_extended(const char * command,
                                const SPIPrepareOptions * options)
```

### Description

`SPI_prepare_extended` creates and returns a prepared statement for the specified command, but doesn't execute the command. This function is equivalent to `SPI_prepare`, with the addition that the caller can specify options to control the parsing of external parameter references, as well as other facets of query parsing and planning.

### Arguments

`const char *`` `*`command`*

command string

`const SPIPrepareOptions *`` `*`options`*

struct containing optional arguments

Callers should always zero out the entire *`options`* struct, then fill whichever fields they want to set. This ensures forward compatibility of code, since any fields that are added to the struct in future will be defined to behave backwards-compatibly if they are zero. The currently available *`options`* fields are:

`ParserSetupHook`` `*`parserSetup`*

Parser hook setup function

`void *`` `*`parserSetupArg`*

pass-through argument for *`parserSetup`*

`RawParseMode`` `*`parseMode`*

mode for raw parsing; `RAW_PARSE_DEFAULT` (zero) produces default behavior

`int`` `*`cursorOptions`*

integer bit mask of cursor options; zero produces default behavior

### Return Value

`SPI_prepare_extended` has the same return conventions as `SPI_prepare`.

***

原文：[PostgreSQL 15.19 Documentation](/15/server-programming/server-programming-interface/spi-interface/spi-spi-prepare-extended.md)（英文原文，待翻譯）


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.postgresql.tw/15/server-programming/server-programming-interface/spi-interface/spi-spi-prepare-extended.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
